#!/usr/bin/env python
# -*- coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from __future__ import print_function
from __future__ import unicode_literals
from __future__ import absolute_import
from __future__ import division

from fal_info import FAL_STATEMGR_PATH, ReqTypes
from ionas.request import Request, Entry, EntryList
from product_conf import SUDO_CMD
from fal_info import Results


def send_entry(falcmd, entry, raise_exception=False):
    try:
        entrylist = EntryList()
        entrylist.append_entry(entry)
        print(str(entrylist))
        req = Request(falcmd, filter_cmd=SUDO_CMD)
        res = req.request(entrylist)
        return res.get_entrylist().get_entry()
    except Exception as e:
        if raise_exception:
            raise
        return None


def change_status(category, state, raise_exception=False):
    STATEMGR_CHANGE_FMT = \
        """<statemgr><state category='%s'>%s</state></statemgr>"""
    try:
        entry = Entry(ReqTypes.CHANGE, STATEMGR_CHANGE_FMT % (category, state))
        entry = send_entry(
            FAL_STATEMGR_PATH,
            entry,
            raise_exception=raise_exception,
        )
        return entry.get_result() in (Results.OK,)
    except Exception as err:
        if raise_exception:
            raise
        return False


def set_busy_status(raise_exception=False):
    return change_status("system", "busy", raise_exception)


def unset_busy_status(raise_exception=False):
    return change_status("system", "running", raise_exception)
